Index: wiki/Manual.wiki
===================================================================
--- wiki/Manual.wiki	(revision 14)
+++ wiki/Manual.wiki	(revision 15)
@@ -26,4 +26,5 @@
   * IDE_AT.BIN (AT build)
    AT build is meant for all AT class machines (16-bit or 32-bit bus). AT build supports OS hooks to allow operating system to do some processing while drive seeks the requested data. By default, the AT build is configured to full mode to take advantage of all the features the XTIDE Universal BIOS offers.
+
 ----
 
@@ -55,4 +56,5 @@
 
 Some menu items appear only when needed to make configuring easier.
+
 
 == Menuitems on main menu ==
@@ -69,4 +71,5 @@
   * Flash EEPROM
    Settings for EEPROM flashing.
+
 
 == Menuitems on Configure XTIDE Universal BIOS submenu ==
@@ -91,4 +94,5 @@
   * Number of IDE controllers
    Number of IDE controllers handled by XTIDE Universal BIOS. This menu item appears only when full operating mode is enabled.
+
 
 == Menuitems on IDE Controller submenus ==
@@ -116,4 +120,5 @@
    IRQ channel to use. All controllers managed by XTIDE Universal BIOS can use the same IRQ when MS-DOS is used. Other operating systems are likely to require different interrupts for each controller. This menu item appears only when interrupts are enabled.
 
+
 == Menuitems on Master and Slave drive submenus ==
   * Block mode transfers
@@ -125,4 +130,5 @@
   * Sectors per track
    Number of user specified P-CHS cylinders, heads and sectors per track. These menu items appear only when user specified CHS is enabled.
+
 
 == Menuitems on Boot menu settings submenu ==
@@ -151,4 +157,5 @@
     Uses main BIOS boot loader or boot loader provided by some other BIOS. System boot loader works only when late initialization is disabled since late initialization is done on a boot loader.
 
+
 == Settings for Flash EEPROM submenu ==
   * Back to previous menu
@@ -191,44 +198,22 @@
 Boot menu can display a little bit information about the drive. Drive information can be disabled with idecfg.com.
 
-
-=== Drive capacity ===
-
-Boot menu displays drive type for floppy drives. The type is read from BIOS and it is the same you usually set in CMOS setup. XT systems do not support the BIOS function to return drive type so 5.25" or 3.5" DD is displayed.
-
-For foreign hard disks (hard disks not handled by XTIDE Universal BIOS) the boot menu displays capacity calculated from CHS-parameters returned by BIOS function INT 13h, AH=8h. It is the same capacity that MS-DOS 6.xx and older versions see.
-
-Same CHS-capacity is displayed for hard disks handled by XTIDE Universal BIOS. In addition to the CHS capacity, the boot menu will display another size that is the full size of the hard disk.
-
-
-=== Drive configuration information ===
-
-Drive configuration information is displayed for XTIDE Universal BIOS controlled drives. Information includes:
-
-==== Addressing (Addr.) ====
-This can be L-CHS, P-CHS, LBA28 or LBA48.
-
-CHS addressing is the old type of addressing method where cylinder, head and sector numbers will be handled separately. Original PC BIOS functions are designed for CHS addressing with maximum  hard disk size being 7.8 GiB (8.4 GB) when some CHS translation method is being used.
-
-LBA addressing is modern addressing method where every sector has its own address. There are no cylinders or heads anymore. Enhanced BIOS functions were introduced for LBA drives but they are not supported before Windows 95 (DOS 7). These EBIOS function are not yet supported by XTIDE Universal BIOS. CHS address must be translated to LBA address when using old CHS BIOS functions with LBA addressing.
-
-L-CHS (known as NORMAL on many old BIOSes) is used for drives <= 504 MiB that can accept the CHS parameters without translation. That makes L-CHS the fastest addressing method.
-
-P-CHS (known as LARGE on many old BIOSes) is used for drives from 504 MiB up to 7.8 GiB. This is a bit slower than L-CHS since simple translation is required to make BIOS L-CHS parameters compatible with IDE P-CHS parameters.
-
-LBA28 (28-bit address) allows drive sizes up to 128 GiB (137 GB). L-CHS to LBA translation is more complex and slower than L-CHS to P-CHS conversion.
-
-LBA48 (48-bit address) work just like LBA28 but with 20 more address bits.
-
-==== Block mode (Block) ====
-Block size in sectors for block mode transfers. XTIDE Universal BIOS always uses largest supported block size. Block mode is disabled or not supported if this is 1.
-
-==== Bus type (Bus) ====
-Displays the bus type that has been selected with idecfg.com.
-
-==== IRQ ====
-Displays IRQ channel if IRQ has been enabled.
-
-==== Reset ====
-Displays status information from drive reset and initialization. This should always be 00h. Anything else would indicate some sort of error. Let me know if you see something other than 00h.
+  * Drive capacity
+   Boot menu displays drive type for floppy drives. The type is read from BIOS and it is the same you usually set in CMOS setup. XT systems do not support the BIOS function to return drive type so 5.25" or 3.5" DD is displayed. For foreign hard disks (hard disks not handled by XTIDE Universal BIOS) the boot menu displays capacity calculated from CHS-parameters returned by BIOS function INT 13h, AH=8h. It is the same capacity that MS-DOS 6.xx and older versions see. Same CHS-capacity is displayed for hard disks handled by XTIDE Universal BIOS. In addition to the CHS capacity, the boot menu will display another size that is the full size of the hard disk.
+  * Drive configuration information is displayed for XTIDE Universal BIOS controlled drives. Information includes:
+   * Addressing (Addr.)
+    This can be L-CHS, P-CHS, LBA28 or LBA48. CHS addressing is the old type of addressing method where cylinder, head and sector numbers will be handled separately. Original PC BIOS functions are designed for CHS addressing with maximum  hard disk size being 7.8 GiB (8.4 GB) when some CHS translation method is being used. LBA addressing is modern addressing method where every sector has its own address. There are no cylinders or heads anymore. Enhanced BIOS functions were introduced for LBA drives but they are not supported before Windows 95 (DOS 7). These EBIOS function are not yet supported by XTIDE Universal BIOS. CHS address must be translated to LBA address when using old CHS BIOS functions with LBA addressing.
+    * L-CHS (known as NORMAL on many old BIOSes) is used for drives <= 504 MiB that can accept the CHS parameters without translation. That makes L-CHS the fastest addressing method.
+    * P-CHS (known as LARGE on many old BIOSes) is used for drives from 504 MiB up to 7.8 GiB. This is a bit slower than L-CHS since simple translation is required to make BIOS L-CHS parameters compatible with IDE P-CHS parameters.
+    * LBA28 (28-bit address) allows drive sizes up to 128 GiB (137 GB). L-CHS to LBA translation is more complex and slower than L-CHS to P-CHS conversion.
+    * LBA48 (48-bit address) work just like LBA28 but with 20 more address bits.
+   * Block mode (Block)
+    Block size in sectors for block mode transfers. XTIDE Universal BIOS always uses largest supported block size. Block mode is disabled or not supported if this is 1.
+   * Bus type (Bus)
+    Displays the bus type that has been selected with idecfg.com.
+   * IRQ
+    Displays IRQ channel if IRQ has been enabled.
+   * Reset
+    Displays status information from drive reset and initialization. This should always be 00h. Anything else would indicate some sort of error. Let me know if you see something other than 00h.
+
 ----
 
@@ -242,4 +227,5 @@
 
 XTIDE Universal BIOS does not support any specific VLB controllers at the moment. I'm planning to add support for Vision QD6580 controller soon.
+
 ----
 